package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import soot.Type;
import abc.impact.impact.Mutation;
import ca.mcgill.sable.abc.impact.visualizer.actions.RunImpactAnalysisActionDelegate;

public final class MutationMutatedTypeFieldTreeNode extends AbstractTreeNode 
	implements IActJavaElement {

	private final Mutation mutation;
	private final Type mutatedType;
	private final IJavaElement jEle;
	
	public MutationMutatedTypeFieldTreeNode(ITreeNode parent, final Mutation mutation, final Type type) {
		super(parent);
		this.mutation = mutation;
		this.mutatedType = type;
		this.name = type + ".[" + mutation.getMutatedFieldName() + "]"; 
		this.image = ImageFactory.STATE_FIELD.getImage();
		
		IJavaElement ret = null;
		try {
			IJavaProject jProject = JavaCore.create(RunImpactAnalysisActionDelegate.getCurrentProject());
			IType jType = jProject.findType(mutatedType.toString());
			ret = jType;
		} catch (JavaModelException e) {
			e.printStackTrace();
		} catch (Exception e) { //prevent exceptions ceasing the following code 
			e.printStackTrace();
		}
		this.jEle = ret;
	}

	public Mutation getMutation() {
		return mutation;
	}

	public Type getMutatedType() {
		return mutatedType;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

	public IJavaElement getJavaElement() {
		return jEle;
	}

}
