package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jdt.ui.JavaUI;

/**
 * getName() returns package name
 * @author Dehua Zhang
 *
 */
public final class PackageTreeNode extends AbstractTreeNode 
	implements IActCollapse {

	/**
	 * @param parent
	 * @param packageName name of the package
	 */
	public PackageTreeNode(ITreeNode parent, String packageName) {
		super(parent, (packageName.equals("") ? "(default package)" : packageName), 
				JavaUI.getSharedImages().getImage(
						org.eclipse.jdt.ui.ISharedImages.IMG_OBJS_PACKAGE));
		//Note: can not get the IPackageFragment
	}
	
	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}
}
