package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Assert;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IJavaProject;

public final class ProjectTreeNode extends AbstractTreeNode 
	implements IActCollapse, IProvideJavaElementImage, IProvideJavaElementText {

	private IJavaProject javaProject;
	
	public ProjectTreeNode(ITreeNode parent, IJavaProject jProject) {
		super(parent);
		Assert.isNotNull(jProject);
		this.javaProject = jProject;
	}

	public IJavaProject getJavaProject() {
		return javaProject;
	}

	public Object getAdapter(Class adapter) {
		if (adapter.isInstance(javaProject))
			return javaProject;
		return null;
	}

	public IJavaElement getJavaElement() {
		return javaProject;
	}
}
